Subject: RE: issue 24

From: "Abarbanel, Benjamin" <[email-masked]>
Date: Thu, 26 Sep 2002 20:06:40 -0400

Curtis:

Comment below

-----Original Message-----
From: Curtis Villamizar
To: Abarbanel, Benjamin
Cc: 'Yakov Rekhter'; [email-masked]
Sent: 9/26/02 12:20 PM
Subject: Re: issue 24 

In message
<[email-masked]>, 
"Abarbanel, Benjamin" writes:
> Yakov,
> 
> > -----Original Message-----
> > From: Yakov Rekhter [mailto:[email-masked]]
> > Sent: Wednesday, September 25, 2002 5:02 PM
> > To: Abarbanel, Benjamin
> > Cc: [email-masked]
> > Subject: Re: issue 24 
> > 
> > 
> > Ben,
> > 
> > > Jeff:
> > > 
> > >   I was just responding to Yakove comment:
> > > 
> > > "By *definition* a route is a <path attribute, NLRI> pair. From
that
> > > definition it follows that changing one or more path attributes of
> > > a route means changing a route, which means withdrawing the old
> > > route (route with the old attributes) from service and advertising
> > > a new route (route with the new attributes)."
> > > 
> > > I think we are playing with words here, 3.1a and 3.1b do not
address
> > > the point as I have argued. Therefore, I am still not satisfied 
> > > we nailed it down in the spec. 
> > > 
> > > As you can see I dont care for assumptions very much.
> > > 
> > > I would like to see this statement added somewhere in section 3.1:
> > > 
> > > "A route's attributes can be added, modified, or deleted by 
> > sending another
> > >  UPDATE message with the same route and the new attributes, or by
> > > withdrawing
> > >  the route (route with the old attributes) from service and 
> > advertising
> > >  a new route (same route with the new attributes)."
> > 
> > If it is "the same route", then *by definition* of a route it 
> > has to be
> > the same attributes. And if the attributes changed, then it 
> > is no longer
> > "the same route". With this in mind how about adding the 
> > following to 3.1:
> > 
> >   Changing attribute of a route means that the route is withdrawn
> >   from service, and a replacement route is advertised. The
replacement
> >   route carries new (changed) attributes and has the same NLRI as
the 
> >   route that was withdrawn.
> > 
> > Yakov.
> > 
> 
>   Can we change the current route's attribute without taking it out of
> service
>   (implying no possible network outage)? 
> 
>   If the answer is yes, than you will need an extra sentence. 
> 
>   If the answer is no, then I am happy with your statement.
> 
> Ben

>>> Ben,

>>> It is an atomic operation.  Text stays the same.  No outage.

>>> Curtis

According to Yakov's email quote:

"  Changing attribute of a route means that the route is withdrawn 
   from service, and a replacement route is advertised. The replacement 
   route carries new (changed) attributes and has the same NLRI as the 
   route that was withdrawn. 

The way I interpret this, is that one message is sent with the route being
withdrawn, followed by another message with the same route being
added with new attributes. The transitions between the two messages could
cause a temporary network outage. Thus the operation is not atomic.

Various implementations could interpret what the spec says and perform
the change with either two messages, or one atomic (replace) message. 
 
Even though its obvious to everyone what is meant stating the specifics is
more helpfull than leaving up to your imagination.

BTW, Yakov's latest response in adding a small paragraph text describing  
     this point, covers this point.

I think we can close this issue with that.

Thanks,
Ben